function thelemicDate()
{
	document.getElementById("date").innerHTML = '<span class="sign">&#9737;</span> in ' + zodiacDegree(solarLongitude()) + '<br />  <span class="sign">&#9789;</span> in ' + zodiacDegree(lunarLongitude()) + "<br /> dies  " + thelemicDayOfWeek() + "<br />" + "Anno " + thelemicYear();
}

function thelemicYear() {
	var tarotNumerals = new Array("0", "I", "II", "III", "IV", "V", "VI", "VII", "VIII", "IX", "X", "XI", "XII", "XIII", "XIV", "XV", "XVI", "XVII", "XVIII", "XIX", "XX", "XXI");
	var currentDate = new Date();
	var bigNumeral = Math.floor((currentDate.getFullYear() - 1904) / 22);
	var smallNumeral = (currentDate.getFullYear() - 1904) % 22;
	if (currentDate.getMonth() < 2 || (currentDate.getDate() < 20 && currentDate.getMonth() == 2))
	{		
		if (smallNumeral == 0) 
		{
			bigNumeral--;
			smallNumeral = 21;
		}
		else smallNumeral--;
	}
	
	if (System.Gadget.Settings.readString("yearFormat") == "n")
		return tarotNumerals[bigNumeral] + ":"  + smallNumeral;
	else		
		return tarotNumerals[bigNumeral] + '<span style="font-size:11px">' + tarotNumerals[smallNumeral] + '</span>';
}

function thelemicDayOfWeek()
{
	var dayNames = new Array ("&#9737;", "&#9789;", "&#9794;", "&#9791;", "&#9795;", "&#9792;", "&#9796;");
	return '<span class="sign">' + dayNames[new Date().getDay()] + "</span>";
}

function zodiacDegree(long)
{
	var zodiacSigns = new Array ("&#9800;", "&#9801;", "&#9802;", "&#9803;", "&#9804;", "&#9805;", "&#9806;", "&#9807;", "&#9808;", "&#9809;", "&#9810;", "&#9811;");	
	
	return Math.round(long % 30) + '&deg; <span class="sign">' + zodiacSigns[Math.floor(long / 30)] + "</span>";
}

function solarLongitude()
{
	a = 1;
	var d = dayNumber();
	var e = 0.016709 - 1.151E-9 * d;
	var M = 356.0470 + 0.9856002585 * d;
	var w = 282.9404 + 4.70935E-5 * d;
	var E = M + (180/Math.PI) * e * Math.sin(Radians(M)) * (1+e * Math.cos(Radians(M)));
	E = Rev(E);
	
	var x = a * Math.cos(Radians(E)) - e;
	var y = a * Math.sin(Radians(Rev(E))) * Math.sqrt(1 - e * e);
	
	var v = Deg(Math.atan2(y,x));
	return Math.abs(Rev(v + w) - 0.042);	
}

function lunarLongitude()
{
	var d = dayNumber();
	var a = 60.2666;
	var i = 5.1454;
	var e = 0.054900;
	var w = Rev(318.0634 + 0.1643573223 * d);
	var M = Rev(115.3654 + 13.0649929509 * d);
	var N = Rev(125.1228 - 0.0529538083 * d);
	E = M + (180 / Math.PI) * e * Math.sin(Radians(M)) * (1 + e * Math.cos(Radians(M)));
	E = Rev(E);
	
	
	var E0, E1, Eafterit, E_ErrorBefore;
	var Ebeforeit=E;
	var Iterations=0;
	var E_error=9;

	while ((E_error>0.0005) && (Iterations<20))  // ok - itererer korrekt
   {
   Iterations=Iterations+1;
   E0=E;
   E1= E0-   (E0-  (180/Math.PI)*e*Math.sin(Radians(E0))  -M )         /(  1-e * Math.cos(Radians(E0))) ;

   E=Rev(E1);  
   Eafterit=E;

   if (E<E0) E_error=E0-E 
       else E_error=E-E0;
   
   if (E<Ebeforeit) E_ErrorBefore=Ebeforeit-E
      else E_ErrorBefore=E-Ebeforeit;

   }	
	
	var x = a*(Math.cos(Radians(E)) -e) ;
	var y = a*Math.sin(Radians(Rev(E)))*Math.sqrt(1-e*e);
	var r = Math.sqrt(x*x+y*y);
	var v = Deg(Math.atan2(y,x));
	var xeclip = r*( Math.cos(Radians(N))*Math.cos(Radians(v+w)) - Math.sin(Radians(N)) * Math.sin(Radians(v+w))*Math.cos(Radians(i))   );
	var yeclip = r*( Math.sin(Radians(N))*Math.cos(Radians(v+w)) + Math.cos(Radians(N)) * Math.sin(Radians(v+w))*Math.cos(Radians(i))   );
	
	var moon_longitude = Rev(Deg(Math.atan2(yeclip,xeclip)));
	
	
	var Ms=356.0470 + 0.9856002585 * d; // Suns mean anomaly
	var Ls=Rev(282.9404 + 4.70935E-5 * d + Rev(Ms)); // Suns mean longitude  er feil
	var Mm=Rev(M);            // Moons mean anomaly
	var Lm=Rev(N+w+M) ; // moon mean longitude
	var D=Rev(Lm-Ls); //Moons mean elongation
	var F=Rev(Lm-N);  //Moons argument of latitude
	
	var P_lon1=  -1.274 * Math.sin(Radians(Mm - 2*D));  //  (Evection)
	var P_lon2=    +0.658 * Math.sin(Radians(2*D));     //    (Variation)
	var P_lon3=    -0.186 * Math.sin(Radians(Ms) ) ;    //    (Yearly equation)
	var P_lon4=    -0.059 * Math.sin(Radians(2*Mm - 2*D));
	var P_lon5=    -0.057 * Math.sin(Radians(Mm - 2*D + Ms));
	var P_lon6=    +0.053 * Math.sin(Radians(Mm + 2*D));
	var P_lon7=    +0.046 * Math.sin(Radians(2*D - Ms));
	var P_lon8=    +0.041 * Math.sin(Radians(Mm - Ms));
	var P_lon9=    -0.035 * Math.sin(Radians(D) );     //      (Parallactic equation)
	var P_lon10=    -0.031 * Math.sin(Radians(Mm + Ms));
	var P_lon11=    -0.015 * Math.sin(Radians(2*F - 2*D));
	var P_lon12=    +0.011 * Math.sin(Radians(Mm - 4*D));
	
	var P_lon = P_lon1+P_lon2+P_lon3+P_lon4+P_lon5+P_lon6+P_lon7+P_lon8+P_lon9+P_lon10+P_lon11+P_lon12;
	
	
	return moon_longitude + P_lon - 0.582;
}

function dayNumber()
{
	var today = new Date();
	var d = 367 * today.getFullYear() - Div(  (7 * (today.getFullYear() + (Div((today.getMonth() + 1 + 9),12)))),4 ) + Div((275 * (today.getMonth() + 1)),9) + today.getDate() - 730530;
	return d + today.getHours() / 24 + today.getMinutes() / (60 * 24) + today.getSeconds() / (24 * 60 * 60);
}

function Div(a, b)
{
	return (a - a % b) / b;
}

function Rev(number)
{
	var x;
	x= number -Math.floor(number/360.0)*360 ;
	return x;
}

function Deg(number)
{
	var rad;
	rad=number*180/Math.PI; 
	return rad ;
}

function Radians(number)
{
	var rad;
	rad=number*Math.PI/180; 
	return rad;

}